@import "Variables"
@import "Loading"
@import "Themes"

.App
  font-family: Roboto, Verdana, "Helvetica Neue"
  text-align: center
  height: 100vh
  max-height: 100vh
  display: grid
  grid-template-rows: auto 1fr
  a
    &, &:link, &:visited, &:active
      @include themify()
        color: themed('activeColor')
      text-decoration: none
    &:hover, &:focus
      @include themify()
        color: darken(themed('activeColor'), 10%)
  *, *:before, *:after
    box-sizing: border-box
  h1, h2, h3, h4, h5
    @include themify()
      color: themed('headerColor')
  h1
    font-weight: 400
  h2
    text-transform: uppercase
    font-weight: 300
  form, .form
    h1
      font-size: 3em
      font-weight: 300
      text-align: center
    h5
      text-align: center
      text-transform: uppercase
      @include themify()
        color: themed('mutedColor')
    hr.sep
      @include themify()
        background-color: themed('headerColor')
      box-shadow: none
      border: none
      height: 2px
      width: 25%
      margin: 0px auto 45px auto
    .emoji
      font-size: 1.2em
    .group
      position: relative
      margin: 45px 0
      input, textarea, select
        width: 100%
        &:focus ~ label, &:valid ~ label, &[type=date] ~ label
          top: -14px
          font-size: 12px
          @include themify()
            color: themed('headerColor')
            border-bottom-color: themed('headerColor')
      label
        @include themify()
          color: themed('mutedColor')
        font-size: 16px
        font-weight: normal
        position: absolute
        pointer-events: none
        left: 5px
        top: 10px
        transition: $trans-time ease all
      .bar
        position: relative
        display: block
        &:before
          content: ''
          height: 2px
          width: 0
          bottom: 0px
          position: absolute
          @include themify()
            background-color: themed('headerColor')
          transition: $trans-time ease all
          left: 0%
  textarea
    resize: none
  input, textarea, select
    background: none
    @include themify()
      color: themed('color')
      border-bottom: 1px solid themed('mutedColor')
    option
      color: black
    font-size: 18px
    padding: 10px 10px 10px 5px
    display: block
    border: none
    border-radius: 0
    &:focus
      outline: none
      @include themify()
        border-bottom-color: themed('headerColor')
  input[type="password"]
    letter-spacing: 0.3em
  .checkbox
    position: relative
    text-align: left
    &.inline
      display: inline-block
    label
      cursor: pointer
      display: inline
      line-height: $md-checkbox-size
      vertical-align: top
      clear: both
      padding-left: 1px
      &:not(:empty)
        padding-left: $md-checkbox-label-padding
      &:before, &:after
        content: ""
        position: absolute
        left: 0
        top: 0
      &:before
        width: $md-checkbox-size
        height: $md-checkbox-size
        background: #fff
        border: $md-checkbox-border-width solid $md-checkbox-border-color
        border-radius: $md-checkbox-border-radius
        cursor: pointer
        transition: background .3s
      &:after
        // checkmark
    input[type="checkbox"]
      outline: 0
      visibility: hidden
      width: $md-checkbox-size
      margin: 0
      display: block
      float: left
      font-size: inherit
      &:checked
        + label:before
          background: $md-checkbox-checked-color
          border:none
        + label:after
          $md-checkmark-size: $md-checkbox-size - 2 * $md-checkbox-padding
          transform: translate($md-checkbox-padding, ($md-checkbox-size / 2) - ($md-checkmark-size / 2.6)) rotate(-45deg)
          width: $md-checkmark-size
          height: $md-checkmark-size / 2
          border: $md-checkmark-width solid $md-checkmark-color
          border-top-style: none
          border-right-style: none
      &:disabled
        + label:before
          border-color: $md-checkbox-border-color-disabled
        &:checked
          + label:before
            background: $md-checkbox-checked-color-disabled
  .btn
    @include themify()
      background-color: themed('color')
      color: mix(black, themed('mutedColor'), 25%)
    cursor: pointer
    border: none
    padding: 10px 20px
    border-radius: 3px
    letter-spacing: 0.06em
    text-transform: uppercase
    text-decoration: none
    outline: none
    box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24)
    transition: all 0.3s cubic-bezier(.25, .8, .25, 1)
    &:hover:not(.disabled)
      @include themify()
        color: mix(black, themed('mutedColor'), 30%)
      box-shadow: 0 7px 14px rgba(0, 0, 0, 0.18), 0 5px 5px rgba(0, 0, 0, 0.12)
    &.active
      @include themify()
        color: themed('color') !important
        background-color: rgba(themed('headerColor'), .4) !important
    &.btn-link
      @include themify()
        background-color: themed('headerColor')
        color: mix(white, themed('headerColor'), 80%)
      &:hover:not(.disabled)
        @include themify()
          background-color: darken(themed('headerColor'), 5%)
          color: mix(white, themed('headerColor'), 85%)
    &.btn-submit
      @include themify()
        background-color: themed('headerColor')
        color: mix(white, themed('headerColor'), 70%)
      &:hover:not(.disabled)
        @include themify()
          background-color: darken(themed('headerColor'), 5%)
          color: mix(white, themed('headerColor'), 85%)
    &.btn-cancel
      @include themify()
        background-color: themed('warnColor')
      color: white
      &:hover:not(.disabled)
        @include themify()
          background-color: darken(themed('warnColor'), 5%)
        color: white
    &.disabled
      cursor: not-allowed
      @include themify()
        color: themed('color')
        background-color: rgba(themed('mutedColor'), .4)
  div
    .success, .warn, .info
      border-radius: .4em
      padding: .8em 2em
      margin: 1em .4em
      color: white
      //border: 2px solid transparent
    .success
      @include themify()
        background-color: themed('successColor')
        border-color: lighten(themed('successColor'), 20%)
    .warn
      @include themify()
        background-color: themed('warnColor')
        border-color: lighten(themed('warnColor'), 20%)
    .info
      @include themify()
        background-color: themed('infoColor')
        border-color: darken(themed('infoColor'), 20%)
  @include themify()
    background-color: themed('backgroundColor')
    color: themed('color')
  .App-header
    display: flex
    flex-direction: row
    align-items: center
    justify-content: center
    font-size: 1em
    padding: 0 1em
    max-height: 3em
    @include themify()
      background-color: themed('primaryColor')
    overflow: hidden
    & > a
      display: grid
      grid-template-columns: auto auto
      margin: .2em 0
      img
        display: inline
        width: auto
        max-height: 2.8em
        margin-right: 1em
      h1
        display: inline
        margin: 0
        small
          font-size: 40%
    ul
      list-style: none
      margin: 0
      padding: 0
      li
        margin-left: 0
        display: inline
        a
          padding: 2em .6em
          &, &:visited, &:active, &:focus
            color: inherit
            text-decoration: none
          &.active
            color: white
            @include themify()
              background-color: themed('activeColor')
          &:hover
            color: white
            @include themify()
              background-color: darken(themed('activeColor'), 10%)
    .spacer
      flex-grow: 1
  .App-wrapper
    overflow-y: auto
    max-width: 1200px
    width: 100%
    margin: 0 auto
    .App-container
      margin: 1em 2em
      @media screen and (max-width: $break-sm)
        margin: 0
        border-radius: 0
        min-height: auto
      @include themify()
        background-color: themed('primaryColor')
      border-radius: 1.5em
      min-height: 40vh
      border-top: 1px solid transparent
      display: flex
      .App-content
        margin-top: -1px
        position: relative
        flex-grow: 1
        @media screen and (max-width: $break-sm)
          padding-left: 0
          padding-right: 0
          padding-bottom: .4em
        padding: .2em .4em
        padding-bottom: 2em
      .App-animation
        &-enter
          opacity: 0
          &-active
            opacity: 1
            transition: opacity 300ms
        &-exit
          opacity: 1
          &-active
            opacity: 0
            transition: opacity 300ms
      .App-loading
        position: absolute
        left: 0
        right: 0
        top: 0
        bottom: 0
        @include themify()
          background-color: rgba(black, .4)
        border-radius: 1.5em
        @media screen and (max-width: $break-sm)
          border-radius: 0
        color: white
        @include loading()
